#define encoderPinA 20
#define encoderPinB 21
volatile int encoderCount = 0;
volatile float angle = 0;
volatile float velocity = 0;
volatile int tcnt2 = 131;
volatile int t = 0;
volatile float angle_previous = 0;
volatile float angle_post = 0;
volatile int time_ms = 0;

void setup() {
  pinMode(encoderPinA, INPUT); 
  pinMode(encoderPinB, INPUT); 
  
  attachInterrupt(2, doEncoderA, CHANGE);  
  attachInterrupt(3, doEncoderB, CHANGE);  
  
  // setup for Timer2: interrupts every 1 ms
  TIMSK2 &= ~(1<<TOIE2);
  TCCR2A &= ~((1<<WGM21) | (1<<WGM20));
  TCCR2B &= ~(1<<WGM22);
  ASSR &= ~(1<<AS2);
  TIMSK2 &= ~(1<<OCIE2A);
  TCCR2B |= (1<<CS22)  | (1<<CS20);
  TCCR2B &= ~(1<<CS21);
  TCNT2 = tcnt2;
  TIMSK2 |= (1<<TOIE2);
  
  /*--------------------*/
  // for motor
  /*--------------------*/
  // initialize software serial object with baud rate of 38.4 kbps
  Serial1.begin(38400);
  // the Simple Motor Controller must be running for at least 1 ms
  // before we try to send serial data, so we delay here for 5 ms
  delay(5);
  // if the Simple Motor Controller has automatic baud detection
  // enabled, we first need to send it the byte 0xAA (170 in decimal)
  // so that it can learn the baud rate
  Serial1.print(0xAA, BYTE);
  // next we need to send the Exit Safe Start command, which
  // clears the safe-start violation and lets the motor run
  exitSafeStart();
  
  Serial.begin (9600); // for debugging
}

void loop() {
}
