void setup()
{
  // initialize software serial object with baud rate of 38.4 kbps
  Serial1.begin(38400);
  // the Simple Motor Controller must be running for at least 1 ms
  // before we try to send serial data, so we delay here for 5 ms
  delay(5);
  // if the Simple Motor Controller has automatic baud detection
  // enabled, we first need to send it the byte 0xAA (170 in decimal)
  // so that it can learn the baud rate
  Serial1.print(0xAA, BYTE);
  // next we need to send the Exit Safe Start command, which
  // clears the safe-start violation and lets the motor run
  exitSafeStart();
}

void loop()
{
  setMotorSpeed(3200); // full speed is 3200
  delay(1000);
  setMotorSpeed(-3200); // full speed is 3200
  delay(1000);
}
